//+------------------------------------------------------------------+
//|                                                     Ichimoku.mq4 |
//|                      Copyright  2004, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  2004, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net/"

#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1 Cyan //Green //Yellow //Lime //Red
#property indicator_color2 Red //Blue
#property indicator_color3 Gold //Aqua //SandyBrown
#property indicator_color4 Plum //Aqua //Blue //Thistle
#property indicator_color5 Gainsboro //Lime
#property indicator_color6 Magenta //Aqua //Blue //SandyBrown
#property indicator_color7 Aqua //Blue //Thistle
//#property indicator_color3 MediumBlue //LawnGreen
//#property indicator_color4 MediumBlue //Chocolate
//#property indicator_color6 MediumBlue //OrangeRed
//#property indicator_color7 MediumBlue //MediumSeaGreen   

#property indicator_width1 2
#property indicator_width2 2
//#property indicator_width5 1
//#property indicator_width6 1
//#property indicator_width7 1

//---- input parameters
extern int  Tenkan               = 5;
extern int  Kijun                = 12;
extern int  Senkou               = 25;
extern bool Cloudonly            = true; //Show Cloud only
extern bool CloudonlyTHV         = false; //Show Cloud only same as THV
extern bool Chinkou_Off          = false; // True = Don't show Chinkou
//extern bool TrendDataOnly        = false; //turns data off
extern bool   alertsOn           = true;
extern bool   alertsOnCurrent    = False;

extern bool   alertsMessage      = true;
extern bool   alertsSound        = True;
extern bool   alertsEmail        = false;

extern bool   ShowValue        = FALSE;
extern double  Valueloc        = 0.2;
extern int     font            =10;
extern string ValueIdentifier = "ICHval";
extern color  txtUpColor     = LawnGreen; //Green; //SkyBlue; //Green;
extern color  txtDownColor   = Magenta; //Chocolate; //Crimson; //Red;

extern bool   ShowArrows         = TRUE;
extern bool   ShowArrowsONLY     = False;
extern string ArrowsIdentifier   = "IchCloud";
extern color  ArrowUpColor       = LawnGreen; //Gold;
extern color  ArrowDownColor     = Magenta ; //Crimson; //Red;

datetime prevtime = 0;
//---- buffers
double Tenkan_Buffer[];
double Kijun_Buffer[];
double SpanA_Buffer[];
double SpanB_Buffer[];
double Chinkou_Buffer[];
double SpanA2_Buffer[];
double SpanB2_Buffer[];
double trend[];
//----
int a_begin;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(8);  
//----SetIndexStyle(0,.........., CLR_NONE); 
   //SetIndexStyle(0,DRAW_NONE);
   SetIndexStyle(0,DRAW_LINE,3);//STYLE_DOT);
   SetIndexBuffer(0,Tenkan_Buffer);
   SetIndexDrawBegin(0,Tenkan-1);
   SetIndexLabel(0,"b0-Tenkan");
//----
   //SetIndexStyle(1,DRAW_NONE);
   SetIndexStyle(1,DRAW_LINE,3); //STYLE_DOT);
   SetIndexBuffer(1,Kijun_Buffer);
   SetIndexDrawBegin(1,Kijun-1);
   SetIndexLabel(1,"b1-Kijun");
//----
   a_begin=Kijun; if(a_begin<Tenkan) a_begin=Tenkan;
   SetIndexStyle(2,DRAW_HISTOGRAM,STYLE_DOT);
   SetIndexBuffer(2,SpanA_Buffer);
   SetIndexDrawBegin(2,Kijun+a_begin-1);
   SetIndexShift(2,Kijun);
   SetIndexLabel(2,"b2-SpanA_Buffer");
   SetIndexStyle(5,DRAW_LINE,STYLE_DOT);
   SetIndexBuffer(5,SpanA2_Buffer);
   SetIndexDrawBegin(5,Kijun+a_begin-1);
   SetIndexShift(5,Kijun);
   SetIndexLabel(5,NULL); //"b5-SpanA2_Buffer");
//----
   SetIndexStyle(3,DRAW_HISTOGRAM,STYLE_DOT);
   SetIndexBuffer(3,SpanB_Buffer);
   SetIndexDrawBegin(3,Kijun+Senkou-1);
   SetIndexShift(3,Kijun);
   SetIndexLabel(3,"b3-SpanB_Buffer");
   SetIndexStyle(6,DRAW_LINE,STYLE_DOT);
   SetIndexBuffer(6,SpanB2_Buffer);
   SetIndexDrawBegin(6,Kijun+Senkou-1);
   SetIndexShift(6,Kijun);
   SetIndexLabel(6,NULL); //"b6-SpanB2_Buffer");
//----
   //SetIndexStyle(4,DRAW_NONE);
   SetIndexStyle(4,DRAW_LINE);
   SetIndexBuffer(4,Chinkou_Buffer);
   SetIndexShift(4,-Kijun);
   SetIndexLabel(4,"b4-Chinkou Span");
   
   SetIndexBuffer(7,trend);
   SetIndexLabel(7,"b7-Ichtrend");
 
   if(Cloudonly) //added rk
   {
   SetIndexStyle(0,DRAW_NONE);
   SetIndexStyle(1,DRAW_NONE);
   SetIndexStyle(4,DRAW_NONE);
   SetIndexStyle(2,DRAW_HISTOGRAM,STYLE_DOT,0,Gold);
   SetIndexStyle(3,DRAW_HISTOGRAM,STYLE_DOT,0,Plum);
   SetIndexStyle(5,DRAW_LINE,STYLE_DASHDOT,1, SandyBrown);
   SetIndexStyle(6,DRAW_LINE,STYLE_DOT,0, Thistle);
   }
   if(CloudonlyTHV) //added rk
   {
   SetIndexStyle(0,DRAW_NONE);
   SetIndexStyle(1,DRAW_NONE);
   SetIndexStyle(4,DRAW_NONE);
   SetIndexStyle(2,DRAW_HISTOGRAM,STYLE_SOLID,5,MediumBlue);
   SetIndexStyle(3,DRAW_HISTOGRAM,STYLE_SOLID,5,MediumBlue);
   SetIndexStyle(5,DRAW_LINE,STYLE_SOLID,5, MediumBlue);
   SetIndexStyle(6,DRAW_LINE,STYLE_SOLID,5, MediumBlue);
   }
  if(Chinkou_Off) //added rk
   {
   SetIndexStyle(4,DRAW_NONE);
   }
   if(ShowArrowsONLY) //added rk
   {
   SetIndexStyle(0,DRAW_NONE);
   SetIndexStyle(1,DRAW_NONE);
   SetIndexStyle(2,DRAW_NONE);
   SetIndexStyle(3,DRAW_NONE);
   SetIndexStyle(4,DRAW_NONE);
   SetIndexStyle(5,DRAW_NONE);
   SetIndexStyle(6,DRAW_NONE);
   }
  /* if(TrendDataOnly)

   SetIndexLabel(0,NULL);
   SetIndexLabel(1,NULL);
   SetIndexLabel(4,NULL);
   SetIndexLabel(5,NULL);
   SetIndexLabel(6,NULL);
   */
//---
   return(0);
  }

int deinit()
{
   if (ShowArrows)
   {
      int compareLength = StringLen(ArrowsIdentifier);
      for (int i=ObjectsTotal(); i>= 0; i--)
      {
         string name = ObjectName(i);
            if (StringSubstr(name,0,compareLength) == ArrowsIdentifier)
                ObjectDelete(name);  
      }
   }
    if (ShowValue)
   {
      int compareLength1 = StringLen(ValueIdentifier);
      for (i=ObjectsTotal()-1; i>= 0; i--)
      {
         string no = ObjectName(i);
            if (StringSubstr(no,0,compareLength1) == ValueIdentifier)
                ObjectDelete(no);  
      }   
   }             


return(0);
}
//+------------------------------------------------------------------+
//| Ichimoku Kinko Hyo                                               |
//+------------------------------------------------------------------+
int start()
  {
   int    i,k;
   int    counted_bars=IndicatorCounted();
   double high,low,price;
//----
   if(Bars<=Tenkan || Bars<=Kijun || Bars<=Senkou) return(0);
//---- initial zero
   if(counted_bars<1)
     {
      for(i=1;i<=Tenkan;i++)    Tenkan_Buffer[Bars-i]=0;
      for(i=1;i<=Kijun;i++)     Kijun_Buffer[Bars-i]=0;
      for(i=1;i<=a_begin;i++) { SpanA_Buffer[Bars-i]=0; SpanA2_Buffer[Bars-i]=0; }
      for(i=1;i<=Senkou;i++)  { SpanB_Buffer[Bars-i]=0; SpanB2_Buffer[Bars-i]=0; }
     }
//---- Tenkan Sen
   i=Bars-Tenkan;
   if(counted_bars>Tenkan) i=Bars-counted_bars-1;
   while(i>=0)
     {
      high=High[i]; low=Low[i]; k=i-1+Tenkan;
      while(k>=i)
        {
         price=High[k];
         if(high<price) high=price;
         price=Low[k];
         if(low>price)  low=price;
         k--;
        }
      Tenkan_Buffer[i]=(high+low)/2;
      i--;
     }
//---- Kijun Sen
   i=Bars-Kijun;
   if(counted_bars>Kijun) i=Bars-counted_bars-1;
   while(i>=0)
     {
      high=High[i]; low=Low[i]; k=i-1+Kijun;
      while(k>=i)
        {
         price=High[k];
         if(high<price) high=price;
         price=Low[k];
         if(low>price)  low=price;
         k--;
        }
      Kijun_Buffer[i]=(high+low)/2;
      i--;
     }
//---- Senkou Span A
   i=Bars-a_begin+1;
   if(counted_bars>a_begin-1) i=Bars-counted_bars-1;
   while(i>=0)
     {
      price=(Kijun_Buffer[i]+Tenkan_Buffer[i])/2;
      SpanA_Buffer[i]=price;
      SpanA2_Buffer[i]=price;
      i--;
     }
//---- Senkou Span B
   i=Bars-Senkou;
   if(counted_bars>Senkou) i=Bars-counted_bars-1;
   while(i>=0)
     {
      high=High[i]; low=Low[i]; k=i-1+Senkou;
      while(k>=i)
        {
         price=High[k];
         if(high<price) high=price;
         price=Low[k];
         if(low>price)  low=price;
         k--;
        }
      price=(high+low)/2;
      SpanB_Buffer[i]=price;
      SpanB2_Buffer[i]=price;
      i--;
     }
//---- Chinkou Span
   i=Bars-1;
   if(counted_bars>1) i=Bars-counted_bars-1;
   while(i>=0) {
       Chinkou_Buffer[i]=Close[i]; i--;
       
//--Set up trend for Cloud crossing       
       trend[i] = trend[i+1];
          if ((Close[i] > SpanB_Buffer[i+Kijun] && Open[i] > SpanB_Buffer[i+Kijun]) && (Close[i] > SpanA_Buffer[i+Kijun] && Open[i] > SpanA_Buffer[i+Kijun])) trend[i] =  1;
          if ((Close[i] < SpanB_Buffer[i+Kijun] && Open[i] < SpanB_Buffer[i+Kijun]) && (Close[i] < SpanA_Buffer[i+Kijun] && Open[i] < SpanA_Buffer[i+Kijun])) trend[i] = -1;
          //if (Close[i] > SpanB_Buffer[i+Kijun] && Close[i] > SpanA_Buffer[i+Kijun]) trend[i] =  1;
          //if (Close[i] < SpanB_Buffer[i+Kijun] && Close[i] < SpanA_Buffer[i+Kijun]) trend[i] = -1;
          
          //if (trend[i+2] == 1 && Tenkan_Buffer[i+2]> Kijun_Buffer[i+2] && Tenkan_Buffer[i+1]< Kijun_Buffer[i+1]) trend[i] = 2;
          //if (trend[i+2] ==-1 && Tenkan_Buffer[i+2]< Kijun_Buffer[i+2] && Tenkan_Buffer[i+1]> Kijun_Buffer[i+1]) trend[i] =-2;
        // if (Close[i] > SpanB_Buffer[i+Kijun] && Close[i] > SpanA_Buffer[i+Kijun] && Close[i] < (Kijun_Buffer[i])) trend[i] =  2;
         //if (Close[i] < SpanB_Buffer[i+Kijun] && Close[i] < SpanA_Buffer[i+Kijun] && Close[i] > (Kijun_Buffer[i])) trend[i] = -2;
         
         manageArrow(i); 
         manageValue(i);
   }
//----
  manageAlerts();  
   return(0);
  }
//+------------------------------------------------------------------+

 void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      if (trend[whichBar]!=trend[whichBar+1]) 
         if (trend[whichBar] ==1) 
               doAlert(whichBar,"up");
         else  doAlert(whichBar,"down");
   }
}
void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       message =  StringConcatenate(Symbol()," tf-",(Period())," at ",
       TimeToStr(TimeLocal(),TIME_SECONDS)," Ichimoku Cloud Alert "+" Close -"+DoubleToStr(Close[0], Digits)+" Ask -"+DoubleToStr(Ask,Digits)
        +" ICH Cloud Breakout---",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"Ichimoku breakout "),message);
          if (alertsSound)   PlaySound("charge.mp3");
   }
}

void manageArrow(int i)
{
   if (ShowArrows)
   {
      double dist = iATR(NULL,0,20,i)/1.0;
      ObjectDelete(ArrowsIdentifier+Time[0]);         
            
      //
      //
      //
      //
      //
           
      if (trend[i] != trend[i+1])
         {
            string name = ArrowsIdentifier+Time[i];
            if (trend[i] == 1)
            {
               ObjectCreate(name,OBJ_ARROW,0, Time[i],Low[i]-dist );
                  ObjectSet(name,OBJPROP_ARROWCODE,74); //241
                  ObjectSet(name,OBJPROP_COLOR,ArrowUpColor);
            }
            else
            if (trend[i] == -1)
            {
               ObjectCreate(name,OBJ_ARROW,0, Time[i],High[i]+dist );
                  ObjectSet(name,OBJPROP_ARROWCODE,74);  //242
                  ObjectSet(name,OBJPROP_COLOR,ArrowDownColor);
            }
         }
   }
}

void manageValue(int i)
{
   if (ShowValue)
   {
      double dist = iATR(NULL,0,20,i)/Valueloc;
      string on = ValueIdentifier+":"+Time[i];
      ObjectDelete(on);         
                
      if (trend[i] != trend[i+1])
         {
            if (trend[i] == 1)
            {
              ObjectCreate(on, OBJ_TEXT, 0, Time[i], Low[i] - dist);
              ObjectSetText(on, DoubleToStr(Close[i], Digits) + " " 
              + TimeToStr(Time[i], TIME_MINUTES), font, "Arial", txtUpColor);
            }
            else
            if (trend[i] == -1)
            {
              ObjectCreate(on, OBJ_TEXT, 0, Time[i], High[i] + dist);
              ObjectSetText(on, DoubleToStr(Close[i], Digits) + " " 
              + TimeToStr(Time[i], TIME_MINUTES), font, "Arial", txtDownColor);
            }
         }
   }
}
//-------------------------------------------

